package com.wms_main.model.vo.wms;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.wms_main.model.po.TSysUser;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.format.annotation.DateTimeFormat;

import java.time.LocalDateTime;

/**
 * 用户Vo
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
public class UserVo {
    /**
     * 登录账号
     */
    @JsonProperty("loginAccount")
    private String loginAccount;
    /**
     * 登录密码
     */
    @JsonProperty("loginPassword")
    private String loginPassword;
    /**
     * 用户名---显示
     */
    @JsonProperty("userName")
    private String userName;
    /**
     * 角色id
     */
    @JsonProperty("roleId")
    private String roleId;
    /**
     * 登录状态
     */
    @JsonProperty("loginStatus")
    private Integer loginStatus;
    /**
     * 账号状态
     */
    @JsonProperty("accountStatus")
    private Integer accountStatus;
    /**
     * 上次登录设备
     */
    @JsonProperty("lastLoginDevice")
    private String lastLoginDevice;
    /**
     * 上次登录时间
     */
    @JsonProperty("lastLoginTime")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private LocalDateTime lastLoginTime;
    /**
     * 添加用户
     */
    @JsonProperty("addUser")
    private String addUser;
    /**
     * 添加时间
     */
    @JsonProperty("addTime")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private LocalDateTime addTime;
    /**
     * 上次更新用户
     */
    @JsonProperty("lastUpdateUser")
    private String lastUpdateUser;
    /**
     * 上次更新时间
     */
    @JsonProperty("lastUpdateTime")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private LocalDateTime lastUpdateTime;

    /**
     * 从po转化为vo
     * @param userPo po
     * @return vo
     */
    public static UserVo ofPo(TSysUser userPo) {
        UserVo userVo = new UserVo();
        userVo.setLoginAccount(userPo.getLoginAccount());
        userVo.setUserName(userPo.getUserName());
        userVo.setRoleId(userPo.getRoleId());
        userVo.setLoginStatus(userPo.getLoginStatus());
        userVo.setAccountStatus(userPo.getAccountStatus());
        userVo.setLastLoginDevice(userPo.getLastLoginDevice());
        userVo.setLastLoginTime(userPo.getLastLoginTime());
        userVo.setAddUser(userPo.getAddUser());
        userVo.setAddTime(userPo.getAddTime());
        userVo.setLastUpdateUser(userPo.getLastUpdateUser());
        userVo.setLastUpdateTime(userPo.getLastUpdateTime());
        return userVo;
    }
}